image: python:3.9

default:
  before_script:
    - pip install poetry
    - poetry run pip install -U pip
    - poetry install

# This folder is cached between builds
# http://docs.gitlab.com/ce/ci/yaml/README.html#cache
cache:
  paths:
    - ~/.cache/pip/

stages:
  - 💎 quality
  - 🚦 test
  - 🚚 deploy

lint:
  stage: 💎 quality
  tags:
    - docker
    - ifb
  script:
    - poetry run inv quality.lint

black:
  stage: 💎 quality
  tags:
    - docker
    - ifb
  script:
    - poetry run inv quality.black-check

test:
  stage: 🚦 test
  tags:
    - docker
    - ifb
  script:
    - poetry run inv tests.cov
  coverage: '/^TOTAL.+?(\d+\%)$/'

publish:
  stage: 🚚 deploy
  only:
    - tags
  tags:
    - docker
    - ifb
  script:
    - poetry build
    - echo "$PYPI_USERNAME"
    - poetry config pypi-token.pypi $PYPI_TOKEN
    - poetry publish
